require 'gotit/mark'

module Gotit
  def self.included(base)
    base.extend Base
  end

  module Reader
    def initialize_reader
      Gotit::Mark.readables.each do |readable|
        mark = Gotit::Mark.find_by(readable: readable, reader: self)
        if mark
          Gotit::Mark.update(timestamp: time.now)
        else
          Gotit::Mark.create(timestamp: time.now, reader: self, readable: readable)
        end
      end
    end
  end

  module Readable

  end

  module Base
    def be_reader
      Gotit::Mark.readers ||= []
      has_many :marks, as: :reader, dependent: :delete_all, inverse_of: :reader
      include Gotit::Reader
      Gotit::Mark.readers << self
      after_create Gotit::Reader.initialize_reader
    end

    def be_reaedable
      Gotit::Mark.readables ||= []
      has_many :marks, as: :readable, dependent: :delete_all, inverse_of: :readable
      Gotit::Mark.readables << self
      self.extend Gotit::Readable
    end
  end
end
